Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 1763)
+++ palm/trunk/SOURCE/Makefile	(revision 1764)
@@ -20,5 +20,6 @@
 # Current revisions:
 # ------------------
-#
+# update dependency of check_parameters, header, local_stop,
+# pmc_handle_communicator
 # 
 # Former revisions:
@@ -327,6 +328,6 @@
 check_for_restart.o: modules.o mod_kinds.o
 check_open.o: modules.o mod_kinds.o mod_particle_attributes.o
-check_parameters.o: modules.o mod_kinds.o subsidence.o land_surface_model.o\
-	plant_canopy_model.o radiation_model.o
+check_parameters.o: modules.o mod_kinds.o land_surface_model.o\
+	plant_canopy_model.o pmc_interface.o radiation_model.o subsidence.o
 close_file.o: modules.o mod_kinds.o
 compute_vpt.o: modules.o mod_kinds.o
@@ -363,5 +364,5 @@
 global_min_max.o: modules.o mod_kinds.o
 header.o: modules.o cpulog.o mod_kinds.o land_surface_model.o\
-          plant_canopy_model.o radiation_model.o subsidence.o 
+          plant_canopy_model.o pmc_interface.o radiation_model.o subsidence.o 
 impact_of_latent_heat.o: modules.o mod_kinds.o
 inflow_turbulence.o: modules.o cpulog.o mod_kinds.o
@@ -385,5 +386,5 @@
 local_flush.o: mod_kinds.o
 local_getenv.o: modules.o mod_kinds.o
-local_stop.o: modules.o mod_kinds.o
+local_stop.o: modules.o mod_kinds.o pmc_interface.o
 local_tremain.o: modules.o cpulog.o mod_kinds.o
 local_tremain_ini.o: modules.o cpulog.o mod_kinds.o
@@ -419,5 +420,5 @@
 lpm_write_restart_file.o: modules.o mod_kinds.o mod_particle_attributes.o
 ls_forcing.o: modules.o cpulog.o mod_kinds.o
-message.o: modules.o mod_kinds.o
+message.o: modules.o mod_kinds.o pmc_interface.o
 microphysics.o: modules.o cpulog.o mod_kinds.o
 modules.o: modules.f90 mod_kinds.o
@@ -430,10 +431,12 @@
 palm.o: modules.o cpulog.o ls_forcing.o mod_kinds.o nudging.o\
 	pmc_interface.o surface_layer_fluxes.o
-parin.o: modules.o cpulog.o mod_kinds.o progress_bar.o
+parin.o: modules.o cpulog.o mod_kinds.o pmc_interface.o progress_bar.o
 plant_canopy_model.o: modules.o mod_kinds.o
 pmc_interface.o: modules.o mod_kinds.o pmc_client.o pmc_general.o\
 	pmc_handle_communicator.o pmc_mpi_wrapper.o pmc_server.o
-pmc_client.o: pmc_general.o pmc_handle_communicator.o pmc_mpi_wrapper.o
-pmc_handle_communicator.o: pmc_general.o
+pmc_client.o: mod_kinds.o pmc_general.o pmc_handle_communicator.o\
+   pmc_mpi_wrapper.o
+pmc_general.o: mod_kinds.o
+pmc_handle_communicator.o: modules.o mod_kinds.o pmc_general.o
 pmc_mpi_wrapper.o: pmc_handle_communicator.o
 pmc_server.o: pmc_general.o pmc_handle_communicator.o pmc_mpi_wrapper.o
Index: palm/trunk/SOURCE/boundary_conds.f90
===================================================================
--- palm/trunk/SOURCE/boundary_conds.f90	(revision 1763)
+++ palm/trunk/SOURCE/boundary_conds.f90	(revision 1764)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! index bug for u_p at left outflow removed
 !
 ! Former revisions:
@@ -820,8 +820,8 @@
 !--       Top boundary at the outflow
           IF ( ibc_uv_t == 0 )  THEN
-             u_p(nzt+1,:,-1) = u_init(nzt+1)
+             u_p(nzt+1,:,0)  = u_init(nzt+1)
              v_p(nzt+1,:,-1) = v_init(nzt+1)
           ELSE
-             u_p(nzt+1,:,-1) = u_p(nzt,:,-1)
+             u_p(nzt+1,:,0)  = u_p(nzt,:,0)
              v_p(nzt+1,:,-1) = v_p(nzt,:,-1)
           ENDIF
Index: palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- palm/trunk/SOURCE/check_parameters.f90	(revision 1763)
+++ palm/trunk/SOURCE/check_parameters.f90	(revision 1764)
@@ -19,5 +19,6 @@
 ! Current revisions:
 ! -----------------
-! 
+! output of nest id in run description header,
+! bugfix: check of validity of lateral boundary conditions moved to parin
 ! 
 ! Former revisions:
@@ -312,4 +313,6 @@
     USE pegrid
     USE plant_canopy_model_mod
+    USE pmc_interface,                                                         &
+        ONLY:  cpl_id, nested_run
     USE profil_parameter
     USE radiation_model_mod
@@ -328,4 +331,6 @@
     CHARACTER (LEN=8)   ::  date                     !< 
     CHARACTER (LEN=10)  ::  time                     !< 
+    CHARACTER (LEN=10)  ::  ensemble_string          !<
+    CHARACTER (LEN=15)  ::  nest_string              !<
     CHARACTER (LEN=40)  ::  coupling_string          !< 
     CHARACTER (LEN=100) ::  action                   !< 
@@ -583,20 +588,23 @@
     ELSEIF ( coupling_mode == 'ocean_to_atmosphere' )  THEN
        coupling_string = ' coupled (ocean)'
-    ENDIF       
-
+    ENDIF
     IF ( ensemble_member_nr /= 0 )  THEN
-       WRITE ( run_description_header,                                         &
-                  '(A,2X,A,2X,A,A,A,I2.2,A,2X,A,I2.2,2X,A,A,2X,A,1X,A)' )      &
-              TRIM( version ), TRIM( revision ), 'run: ',                      &
-              TRIM( run_identifier ), '.', runnr, TRIM( coupling_string ),     &
-              'en-no: ', ensemble_member_nr,'host: ', TRIM( host ),            &
-              run_date, run_time
+       WRITE( ensemble_string, '(2X,A,I2.2)' )  'en-no: ', ensemble_member_nr
     ELSE
-       WRITE ( run_description_header,                                         &
-                  '(A,2X,A,2X,A,A,A,I2.2,A,2X,A,A,2X,A,1X,A)' )                &
-              TRIM( version ), TRIM( revision ), 'run: ',                      &
-              TRIM( run_identifier ), '.', runnr, TRIM( coupling_string ),     &
-              'host: ', TRIM( host ), run_date, run_time
-    ENDIF
+       ensemble_string = ''
+    ENDIF
+    IF ( nested_run )  THEN
+       WRITE( nest_string, '(2X,A,I2.2)' )  'nest-id: ', cpl_id
+    ELSE
+       nest_string = ''
+    ENDIF
+
+    WRITE ( run_description_header,                                            &
+            '(A,2X,A,2X,A,A,A,I2.2,A,A,A,2X,A,A,2X,A,1X,A)' )                  &
+          TRIM( version ), TRIM( revision ), 'run: ',                          &
+          TRIM( run_identifier ), '.', runnr, TRIM( coupling_string ),         &
+          TRIM( nest_string ), TRIM( ensemble_string), 'host: ', TRIM( host ), &
+          run_date, run_time
+
 !
 !-- Check the general loop optimization method
@@ -1756,27 +1764,6 @@
 !
 !-- Check boundary conditions and set internal variables:
-!-- Lateral boundary conditions
-    IF ( bc_lr /= 'cyclic'  .AND.  bc_lr /= 'dirichlet/radiation'  .AND. &
-         bc_lr /= 'radiation/dirichlet'  .AND.  bc_lr /= 'nested' )  THEN
-       message_string = 'unknown boundary condition: bc_lr = "' // &
-                        TRIM( bc_lr ) // '"'
-       CALL message( 'check_parameters', 'PA0049', 1, 2, 0, 6, 0 )
-    ENDIF
-    IF ( bc_ns /= 'cyclic'  .AND.  bc_ns /= 'dirichlet/radiation'  .AND. &
-         bc_ns /= 'radiation/dirichlet'  .AND.  bc_ns /= 'nested' )  THEN
-       message_string = 'unknown boundary condition: bc_ns = "' // &
-                        TRIM( bc_ns ) // '"'
-       CALL message( 'check_parameters', 'PA0050', 1, 2, 0, 6, 0 )
-    ENDIF
-
-!
-!-- Internal variables used for speed optimization in if clauses
-    IF ( bc_lr /= 'cyclic' )               bc_lr_cyc    = .FALSE.
-    IF ( bc_lr == 'dirichlet/radiation' )  bc_lr_dirrad = .TRUE.
-    IF ( bc_lr == 'radiation/dirichlet' )  bc_lr_raddir = .TRUE.
-    IF ( bc_ns /= 'cyclic' )               bc_ns_cyc    = .FALSE.
-    IF ( bc_ns == 'dirichlet/radiation' )  bc_ns_dirrad = .TRUE.
-    IF ( bc_ns == 'radiation/dirichlet' )  bc_ns_raddir = .TRUE.
-
+!-- Attention: the lateral boundary conditions have been already checked in
+!-- parin
 !
 !-- Non-cyclic lateral boundaries require the multigrid method and Piascek-
Index: palm/trunk/SOURCE/header.f90
===================================================================
--- palm/trunk/SOURCE/header.f90	(revision 1763)
+++ palm/trunk/SOURCE/header.f90	(revision 1764)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! output of nesting informations
 !
 ! Former revisions:
@@ -205,5 +205,5 @@
 ! Description:
 ! ------------
-!> Writing a header with all important information about the actual run.
+!> Writing a header with all important information about the current run.
 !> This subroutine is called three times, two times at the beginning 
 !> (writing information on files RUN_CONTROL and HEADER) and one time at the
@@ -269,4 +269,8 @@
                plant_canopy
 
+    USE pmc_interface,                                                         &
+        ONLY:  cpl_id, cpl_parent_id, cpl_name, lower_left_coord_x,            &
+               lower_left_coord_y, nested_run, nesting_mode
+
     USE radiation_model_mod,                                                   &
         ONLY:  albedo, albedo_type, albedo_type_name, constant_albedo,         &
@@ -366,17 +370,18 @@
 !-- Determine kind of model run
     IF ( TRIM( initializing_actions ) == 'read_restart_data' )  THEN
-       run_classification = '3D - restart run'
+       run_classification = 'restart run'
     ELSEIF ( TRIM( initializing_actions ) == 'cyclic_fill' )  THEN
-       run_classification = '3D - run with cyclic fill of 3D - prerun data'
+       run_classification = 'run with cyclic fill of 3D - prerun data'
     ELSEIF ( INDEX( initializing_actions, 'set_constant_profiles' ) /= 0 )  THEN
-       run_classification = '3D - run without 1D - prerun'
+       run_classification = 'run without 1D - prerun'
     ELSEIF ( INDEX( initializing_actions, 'set_1d-model_profiles' ) /= 0 )  THEN
-       run_classification = '3D - run with 1D - prerun'
+       run_classification = 'run with 1D - prerun'
     ELSEIF ( INDEX( initializing_actions, 'by_user' ) /=0 )  THEN
-       run_classification = '3D - run initialized by user'
+       run_classification = 'run initialized by user'
     ELSE
        message_string = ' unknown action(s): ' // TRIM( initializing_actions )
        CALL message( 'header', 'PA0191', 0, 0, 0, 6, 0 )
     ENDIF
+    IF ( nested_run )  run_classification = 'nested ' // run_classification
     IF ( ocean )  THEN
        run_classification = 'ocean - ' // run_classification
@@ -444,4 +449,11 @@
     IF ( num_acc_per_node /= 0 )  WRITE ( io, 120 )  num_acc_per_node
 #endif
+
+!
+!-- Nesting informations
+    IF ( nested_run )  THEN
+       WRITE ( io, 600 )  cpl_id, TRIM( cpl_name ), cpl_parent_id,             &
+                          nesting_mode, lower_left_coord_x, lower_left_coord_y
+    ENDIF
     WRITE ( io, 99 )
 
@@ -2399,5 +2411,8 @@
 513 FORMAT (' --> Scalar advection via Wicker-Skamarock-Scheme 5th order ' // & 
             '+ monotonic adjustment')
-
+600 FORMAT (/' Nesting informations:'/                                        &
+            ' Nest id / name:                   ',I2.2,' / ',A,' (parent id: ',I2.2,')'/ &
+            ' Nesting mode:                     ',A/ &
+            ' Lower left corner coordinates:    ','x = ',F8.2,' m, y = ',F8.2,' m'/)
 
  END SUBROUTINE header
Index: palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- palm/trunk/SOURCE/init_3d_model.f90	(revision 1763)
+++ palm/trunk/SOURCE/init_3d_model.f90	(revision 1764)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! bugfix: increase size of volume_flow_area_l and volume_flow_initial_l by 1
 !
 ! Former revisions:
@@ -302,6 +302,6 @@
     INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  ngp_2dh_s_inner_l  !<
 
-    REAL(wp), DIMENSION(1:2) ::  volume_flow_area_l     !<
-    REAL(wp), DIMENSION(1:2) ::  volume_flow_initial_l  !<
+    REAL(wp), DIMENSION(1:3) ::  volume_flow_area_l     !<
+    REAL(wp), DIMENSION(1:3) ::  volume_flow_initial_l  !<
 
     REAL(wp), DIMENSION(:), ALLOCATABLE ::  mean_surface_level_height_l    !<
Index: palm/trunk/SOURCE/init_pegrid.f90
===================================================================
--- palm/trunk/SOURCE/init_pegrid.f90	(revision 1763)
+++ palm/trunk/SOURCE/init_pegrid.f90	(revision 1764)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! ------------------
-!
+! cpp-statements for nesting removed
 ! 
 ! Former revisions:
@@ -151,8 +151,6 @@
     USE pegrid
  
-#if defined( PMC_ACTIVE )
     USE pmc_interface,                                                         &
-        ONLY:  cpl_npex,cpl_npey
-#endif
+        ONLY:  cpl_npex, cpl_npey, nested_run
 
     USE transpose_indices,                                                     &
@@ -215,49 +213,53 @@
     CALL location_message( 'creating virtual PE grids + MPI derived data types', &
                            .FALSE. )
-#if defined( PMC_ACTIVE )
-!
-!-- In case of nested-domain runs, the processor grid is explicitly given
-!-- by the user in the nestpar-NAMELIST
-    pdims(1) = cpl_npex
-    pdims(2) = cpl_npey
-#else
-!
-!-- Determine the processor topology or check it, if prescribed by the user
-    IF ( npex == -1  .AND.  npey == -1 )  THEN
-
-!
-!--    Automatic determination of the topology
-       numproc_sqr = SQRT( REAL( numprocs, KIND=wp ) )
-       pdims(1)    = MAX( numproc_sqr , 1 )
-       DO  WHILE ( MOD( numprocs , pdims(1) ) /= 0 )
-          pdims(1) = pdims(1) - 1
-       ENDDO
-       pdims(2) = numprocs / pdims(1)
-
-    ELSEIF ( npex /= -1  .AND.  npey /= -1 )  THEN
-
-!
-!--    Prescribed by user. Number of processors on the prescribed topology
-!--    must be equal to the number of PEs available to the job
-       IF ( ( npex * npey ) /= numprocs )  THEN
-          WRITE( message_string, * ) 'number of PEs of the prescribed ',      & 
+
+    IF ( nested_run )  THEN
+!
+!--    In case of nested-domain runs, the processor grid is explicitly given
+!--    by the user in the nestpar-NAMELIST
+       pdims(1) = cpl_npex
+       pdims(2) = cpl_npey
+
+    ELSE
+!
+!--    Determine the processor topology or check it, if prescribed by the user
+       IF ( npex == -1  .AND.  npey == -1 )  THEN
+
+!
+!--       Automatic determination of the topology
+          numproc_sqr = SQRT( REAL( numprocs, KIND=wp ) )
+          pdims(1)    = MAX( numproc_sqr , 1 )
+          DO  WHILE ( MOD( numprocs , pdims(1) ) /= 0 )
+             pdims(1) = pdims(1) - 1
+          ENDDO
+          pdims(2) = numprocs / pdims(1)
+
+       ELSEIF ( npex /= -1  .AND.  npey /= -1 )  THEN
+
+!
+!--       Prescribed by user. Number of processors on the prescribed topology
+!--       must be equal to the number of PEs available to the job
+          IF ( ( npex * npey ) /= numprocs )  THEN
+             WRITE( message_string, * ) 'number of PEs of the prescribed ',   &
                  'topology (', npex*npey,') does not match & the number of ', & 
                  'PEs available to the job (', numprocs, ')'
-          CALL message( 'init_pegrid', 'PA0221', 1, 2, 0, 6, 0 )
-       ENDIF
-       pdims(1) = npex
-       pdims(2) = npey
-
-    ELSE
-!
-!--    If the processor topology is prescribed by the user, the number of
-!--    PEs must be given in both directions
-       message_string = 'if the processor topology is prescribed by the, ' //  &
-                   ' user& both values of "npex" and "npey" must be given ' // &
-                   'in the &NAMELIST-parameter file'
-       CALL message( 'init_pegrid', 'PA0222', 1, 2, 0, 6, 0 )
-
-    ENDIF
-#endif
+             CALL message( 'init_pegrid', 'PA0221', 1, 2, 0, 6, 0 )
+          ENDIF
+          pdims(1) = npex
+          pdims(2) = npey
+
+       ELSE
+!
+!--       If the processor topology is prescribed by the user, the number of
+!--       PEs must be given in both directions
+          message_string = 'if the processor topology is prescribed by th' //  &
+                   'e user& both values of "npex" and "npey" must be given' // &
+                   ' in the &NAMELIST-parameter file'
+          CALL message( 'init_pegrid', 'PA0222', 1, 2, 0, 6, 0 )
+
+       ENDIF
+
+    ENDIF
+
 
 !
@@ -1082,8 +1084,6 @@
        ELSEIF ( bc_lr == 'radiation/dirichlet' )  THEN
           outflow_l = .TRUE.
-#if defined( PMC_ACTIVE )
        ELSEIF ( bc_lr == 'nested' )  THEN
           nest_bound_l = .TRUE.
-#endif
        ENDIF
     ENDIF
@@ -1094,8 +1094,6 @@
        ELSEIF ( bc_lr == 'radiation/dirichlet' )  THEN
           inflow_r  = .TRUE.
-#if defined( PMC_ACTIVE )
        ELSEIF ( bc_lr == 'nested' )  THEN
           nest_bound_r = .TRUE.
-#endif
        ENDIF
     ENDIF
@@ -1106,8 +1104,6 @@
        ELSEIF ( bc_ns == 'radiation/dirichlet' )  THEN
           inflow_s  = .TRUE.
-#if defined( PMC_ACTIVE )
        ELSEIF ( bc_ns == 'nested' )  THEN
           nest_bound_s = .TRUE.
-#endif
        ENDIF
     ENDIF
@@ -1118,8 +1114,6 @@
        ELSEIF ( bc_ns == 'radiation/dirichlet' )  THEN
           outflow_n = .TRUE.
-#if defined( PMC_ACTIVE )
        ELSEIF ( bc_ns == 'nested' )  THEN
           nest_bound_n = .TRUE.
-#endif
        ENDIF
     ENDIF
Index: palm/trunk/SOURCE/local_stop.f90
===================================================================
--- palm/trunk/SOURCE/local_stop.f90	(revision 1763)
+++ palm/trunk/SOURCE/local_stop.f90	(revision 1764)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! abort with MPI_COMM_WORLD added, nested runs always abort with MPI_ABORT
 ! 
 ! Former revisions:
@@ -55,6 +55,4 @@
  
 
-    USE pegrid
-    
     USE control_parameters,                                                    &
         ONLY:  abort_mode, coupling_mode, coupling_mode_remote, dt_restart,    &
@@ -62,12 +60,25 @@
                terminate_run, time_restart
 
+    USE pegrid
+
+    USE pmc_interface,                                                         &
+        ONLY:  nested_run
 
 #if defined( __parallel ) && ! defined ( __check )
     IF ( coupling_mode == 'uncoupled' )  THEN
-       IF ( abort_mode == 1 )  THEN
-          CALL MPI_FINALIZE( ierr )
-          STOP
-       ELSEIF ( abort_mode == 2 )  THEN
-          CALL MPI_ABORT( comm2d, 9999, ierr )
+       IF ( nested_run )  THEN
+!
+!--       Workaround: If any of the nested model crashes, it aborts the whole
+!--       run with MPI_ABORT, regardless of the reason given by abort_mode
+          CALL MPI_ABORT( MPI_COMM_WORLD, 9999, ierr )
+       ELSE
+          IF ( abort_mode == 1 )  THEN
+             CALL MPI_FINALIZE( ierr )
+             STOP
+          ELSEIF ( abort_mode == 2 )  THEN
+             CALL MPI_ABORT( comm2d, 9999, ierr )
+          ELSEIF ( abort_mode == 3 )  THEN
+             CALL MPI_ABORT( MPI_COMM_WORLD, 9999, ierr )
+          ENDIF
        ENDIF
     ELSE
Index: palm/trunk/SOURCE/message.f90
===================================================================
--- palm/trunk/SOURCE/message.f90	(revision 1763)
+++ palm/trunk/SOURCE/message.f90	(revision 1764)
@@ -19,5 +19,7 @@
 ! Current revisions:
 ! -----------------
-! 
+! nest id added to header string, add linefeed to stdout to get messages better
+! seperatedvfrom the location messages,
+! in case of nested runs, location messages are given only by the root domain
 ! 
 ! Former revisions:
@@ -55,4 +57,5 @@
 !> Meaning of formal parameters:
 !> requested_action: 0 - continue, 1 - abort by stop, 2 - abort by mpi_abort
+!>                   3 - abort by mpi_abort using MPI_COMM_WORLD
 !> message_level: 0 - informative, 1 - warning, 2 - error
 !> output_on_pe: -1 - all, else - output on specified PE
@@ -63,5 +66,4 @@
                      message_level, output_on_pe, file_id, flush )
  
-
     USE control_parameters,                                                    &
         ONLY:  abort_mode, message_string
@@ -71,7 +73,11 @@
     USE pegrid
 
+    USE pmc_interface,                                                         &
+        ONLY:  cpl_id, nested_run
+
     IMPLICIT NONE
 
     CHARACTER(LEN=6)   ::  message_identifier            !<
+    CHARACTER(LEN=20)  ::  nest_string                   !< nest id information
     CHARACTER(LEN=*)   ::  routine_name                  !<
     CHARACTER(LEN=200) ::  header_string                 !<
@@ -94,13 +100,22 @@
 
 !
+!-- In case of nested runs create the nest id informations
+    IF ( nested_run )  THEN
+       WRITE( nest_string, '(1X,A,I2.2)' )  'from nest-id ', cpl_id
+    ELSE
+       nest_string = ''
+    ENDIF
+!
 !-- Create the complete output string, starting with the message level
     IF ( message_level == 0 )  THEN
-       header_string = '--- informative message ---  ID:'
+       header_string = '--- informative message' // TRIM(nest_string) //       &
+                       ' ---  ID:'
     ELSEIF ( message_level == 1 )  THEN
-       header_string = '+++ warning message ---  ID:'
+       header_string = '+++ warning message' // TRIM(nest_string) // ' ---  ID:'
     ELSEIF ( message_level == 2 )  THEN
-       header_string = '+++ error message ---  ID:'
+       header_string = '+++ error message' // TRIM(nest_string) // ' ---  ID:'
     ELSE
-       WRITE( header_string,'(A,I2)' )  '+++ unknown message level: ', &
+       WRITE( header_string,'(A,I2)' )  '+++ unknown message level' //         &
+                                        TRIM(nest_string) // ': ',             &
                                         message_level
     ENDIF
@@ -118,5 +133,5 @@
        information_string_2 = 'http://palm.muk.uni-hannover.de/trac/wiki/doc' // &
                               '/app/errmsg#' // message_identifier
-    END IF
+    ENDIF
     
 
@@ -147,5 +162,5 @@
 !
 !--       Output on stdout
-          WRITE( *, '(A/)' )  TRIM( header_string )
+          WRITE( *, '(//A/)' )  TRIM( header_string )
 !
 !--       Cut message string into pieces and output one piece per line.
@@ -219,8 +234,11 @@
 
     USE, INTRINSIC ::  ISO_FORTRAN_ENV,                                        &
-        ONLY :  OUTPUT_UNIT
+        ONLY:  OUTPUT_UNIT
 
     USE pegrid,                                                                &
-        ONLY :  myid
+        ONLY:  myid
+
+    USE pmc_interface,                                                         &
+        ONLY:  cpl_id
 
     IMPLICIT NONE
@@ -229,4 +247,7 @@
     LOGICAL          ::  advance  !< switch for advancing/noadvancing I/O
 
+!
+!-- Output for nested runs only on the root domain
+    IF ( cpl_id /= 1 )  RETURN
 
     IF ( myid == 0 )  THEN
Index: palm/trunk/SOURCE/modules.f90
===================================================================
--- palm/trunk/SOURCE/modules.f90	(revision 1763)
+++ palm/trunk/SOURCE/modules.f90	(revision 1764)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! some reformatting
 !
 ! Former revisions:
@@ -713,9 +713,11 @@
                 lunudge = .FALSE., lvnudge = .FALSE., lwnudge = .FALSE., &
                 masking_method = .FALSE., mg_switch_to_pe0 = .FALSE., &
-                monotonic_adjustment = .FALSE., &
-                nest_bound_l = .FALSE., nest_bound_n = .FALSE., &
-                nest_bound_r = .FALSE., nest_bound_s = .FALSE., &
-                nest_domain = .FALSE., &
-                neutral = .FALSE., nudging = .FALSE., &
+                monotonic_adjustment = .FALSE.
+    LOGICAL ::  nest_bound_l = .FALSE. !< nested boundary on left side
+    LOGICAL ::  nest_bound_n = .FALSE. !< nested boundary on north side
+    LOGICAL ::  nest_bound_r = .FALSE. !< nested boundary on right side
+    LOGICAL ::  nest_bound_s = .FALSE. !< nested boundary on south side
+    LOGICAL ::  nest_domain  = .FALSE. !< domain is nested into a parent domain
+    LOGICAL ::  neutral = .FALSE., nudging = .FALSE., &
                 ocean = .FALSE., on_device = .FALSE., &
                 outflow_l = .FALSE., outflow_n = .FALSE., outflow_r = .FALSE., &
Index: palm/trunk/SOURCE/palm.f90
===================================================================
--- palm/trunk/SOURCE/palm.f90	(revision 1763)
+++ palm/trunk/SOURCE/palm.f90	(revision 1764)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-!
+! cpp-statements for nesting removed, communicator settings cleaned up
 !
 ! Former revisions:
@@ -148,8 +148,6 @@
     USE pegrid
 
-#if defined( PMC_ACTIVE )
     USE pmc_interface,                                                         &
-        ONLY:  cpl_id, pmci_init, pmci_modelconfiguration
-#endif
+        ONLY:  cpl_id, nested_run, pmci_init, pmci_modelconfiguration
 
     USE statistics,                                                            &
@@ -185,27 +183,34 @@
     CALL MPI_INIT( ierr )
 
-#if defined( PMC_ACTIVE )
 !
 !-- Initialize the coupling for nested-domain runs
+!-- comm_palm is the communicator which includes all PEs (MPI processes)
+!-- available for this (nested) model. If it is not a nested run, comm_palm
+!-- is returned as MPI_COMM_WORLD
     CALL pmci_init( comm_palm )
     comm2d = comm_palm
-
-    IF ( cpl_id >= 2 )  THEN
-       nest_domain = .TRUE.
-       WRITE( coupling_char, '(A1,I1.1)') '_', cpl_id
-    ENDIF
-
-    CALL MPI_COMM_SIZE( comm_palm, numprocs, ierr )
-    CALL MPI_COMM_RANK( comm_palm, myid, ierr )
-#else
-    CALL MPI_COMM_SIZE( MPI_COMM_WORLD, numprocs, ierr )
-    CALL MPI_COMM_RANK( MPI_COMM_WORLD, myid, ierr )
-    comm_palm = MPI_COMM_WORLD
-    comm2d    = MPI_COMM_WORLD
-!
-!-- Initialize PE topology in case of coupled atmosphere-ocean runs (comm_palm
-!-- will be splitted in init_coupling)
-    CALL init_coupling
-#endif
+!
+!-- Get the (preliminary) number of MPI processes and the local PE-id (in case
+!-- of a further communicator splitting in init_coupling, these numbers will
+!-- be changed in init_pegrid).
+    IF ( nested_run )  THEN
+!--    TO_DO: move the following two settings somewehere to the pmc_interface
+       IF ( cpl_id >= 2 )  THEN
+          nest_domain = .TRUE.
+          WRITE( coupling_char, '(A1,I1.1)') '_', cpl_id
+       ENDIF
+
+       CALL MPI_COMM_SIZE( comm_palm, numprocs, ierr )
+       CALL MPI_COMM_RANK( comm_palm, myid, ierr )
+
+    ELSE
+
+       CALL MPI_COMM_SIZE( MPI_COMM_WORLD, numprocs, ierr )
+       CALL MPI_COMM_RANK( MPI_COMM_WORLD, myid, ierr )
+!
+!--    Initialize PE topology in case of coupled atmosphere-ocean runs (comm_palm
+!--    will be splitted in init_coupling)
+       CALL init_coupling
+    ENDIF
 #endif
 
@@ -316,9 +321,9 @@
     CALL init_3d_model
 
-#if defined( PMC_ACTIVE )
 !
 !-- Coupling protocol setup for nested-domain runs
-    CALL pmci_modelconfiguration
-#endif
+    IF ( nested_run )  THEN
+       CALL pmci_modelconfiguration
+    ENDIF
 
 !
Index: palm/trunk/SOURCE/parin.f90
===================================================================
--- palm/trunk/SOURCE/parin.f90	(revision 1763)
+++ palm/trunk/SOURCE/parin.f90	(revision 1764)
@@ -19,5 +19,9 @@
 ! Current revisions:
 ! -----------------
-!
+! cpp-statements for nesting removed, explicit settings of boundary conditions
+! in nest domains,
+! bugfix: npex/npey message moved from inipar to d3par
+! bugfix: check of lateral boundary conditions from check_parameters to here,
+! because they will be already used in init_pegrid and init_grid
 ! 
 ! Former revisions:
@@ -193,8 +197,13 @@
         ONLY:  nx, ny, nz
 
+    USE kinds
+
     USE model_1d,                                                              &
         ONLY:  damp_level_1d, dt_pr_1d, dt_run_control_1d, end_time_1d
 
     USE pegrid
+
+    USE pmc_interface,                                                         &
+        ONLY:  nested_run
 
     USE profil_parameter,                                                      &
@@ -345,26 +354,4 @@
           READ ( 11, inipar, ERR=10, END=11 )
 
-#if defined ( PMC_ACTIVE )
-!
-!--       In nested domains, npex or npey must not be given in \$inipar
-!--       because here the PE-grids are always defined in the nestpar-NAMELIST
-          IF ( ( npex /= -1 ) .OR. ( npey /= -1 ) )  THEN
-             message_string = 'npex or npey must not be given in \$inipar ' // &
-                              'in nested domains'
-             CALL message( 'parin', 'PAXXXX', 1, 2, 0, 6, 0 )
-          ENDIF
-#else
-!
-!--       Make sure that no nesting boundary conditions are defined if
-!--       PMC_ACTIVE is not defined. Otherwise initiate abort.
-          IF ( ( bc_lr == 'nested' ) .OR. ( bc_ns == 'nested' ) .OR. ( bc_uv_t == 'nested' ) .OR. &
-               ( bc_pt_t ==  'nested' ) .OR. ( bc_q_t == 'nested') .OR. ( bc_sa_t == 'nested') .OR. &
-               ( bc_p_t == 'nested' ) ) THEN
-             message_string = 'Nested boundary conditions are not allowed ' // &
-                              'since the cpp flag PMC_ACTIVE is not set'
-             CALL message( 'parin', 'PAXXXX', 1, 2, 0, 6, 0 )
-          ENDIF
-#endif
-
 #if defined ( __check )
 !
@@ -406,4 +393,40 @@
 
 !
+!--       In case of nested runs, explicitly set nesting boundary conditions
+!--       except for the root domain. This will overwrite the user settings.
+          IF ( nest_domain )  THEN
+             bc_lr   = 'nested'
+             bc_ns   = 'nested'
+             bc_uv_t = 'nested'
+             bc_pt_t = 'nested'
+             bc_p_t  = 'neumann'
+          ENDIF
+!
+!--       Check validity of lateral boundary conditions. This has to be done
+!--       here because they are already used in init_pegrid and init_grid and
+!--       therefore cannot be check in check_parameters
+          IF ( bc_lr /= 'cyclic'  .AND.  bc_lr /= 'dirichlet/radiation'  .AND. &
+               bc_lr /= 'radiation/dirichlet'  .AND.  bc_lr /= 'nested' )  THEN
+             message_string = 'unknown boundary condition: bc_lr = "' // &
+                              TRIM( bc_lr ) // '"'
+             CALL message( 'check_parameters', 'PA0049', 1, 2, 0, 6, 0 )
+          ENDIF
+          IF ( bc_ns /= 'cyclic'  .AND.  bc_ns /= 'dirichlet/radiation'  .AND. &
+               bc_ns /= 'radiation/dirichlet'  .AND.  bc_ns /= 'nested' )  THEN
+             message_string = 'unknown boundary condition: bc_ns = "' // &
+                              TRIM( bc_ns ) // '"'
+             CALL message( 'check_parameters', 'PA0050', 1, 2, 0, 6, 0 )
+          ENDIF
+
+!
+!--       Set internal variables used for speed optimization in if clauses
+          IF ( bc_lr /= 'cyclic' )               bc_lr_cyc    = .FALSE.
+          IF ( bc_lr == 'dirichlet/radiation' )  bc_lr_dirrad = .TRUE.
+          IF ( bc_lr == 'radiation/dirichlet' )  bc_lr_raddir = .TRUE.
+          IF ( bc_ns /= 'cyclic' )               bc_ns_cyc    = .FALSE.
+          IF ( bc_ns == 'dirichlet/radiation' )  bc_ns_dirrad = .TRUE.
+          IF ( bc_ns == 'radiation/dirichlet' )  bc_ns_raddir = .TRUE.
+
+!
 !--       Definition of names of areas used for computing statistics. They must
 !--       be defined at this place, because they are allowed to be redefined by
@@ -416,4 +439,16 @@
 !--       values are used for the parameters.
           READ ( 11, d3par, END=20 )
+
+          IF ( nested_run )  THEN
+!
+!--          In nested domains, npex or npey can not be given in the d3par-
+!--          NAMELIST because here the PE-grids are always defined in the
+!--          nestpar-NAMELIST. Settings will be ignored.
+             IF ( ( npex /= -1 ) .OR. ( npey /= -1 ) )  THEN
+                message_string = 'npex or npey can not be given in \$d3par ' // &
+                                 'for nested runs & they will be ignored'
+                CALL message( 'parin', 'PA0352', 0, 1, 0, 6, 0 )
+             ENDIF
+          ENDIF
 
 !
